

`timescale 1 ns / 1 ns

module DSP_test
          (clk,
           reset,
           clk_enable,
           ce_out,
           Out1);


  input   clk;
  input   reset;
  input   clk_enable;
  output  ce_out;
  output  signed [15:0] Out1;  // sfix16_En10


  wire enb;
  wire signed [15:0] Constant1_out1;  // sfix16_En10
  wire [3:0] count_step;  // ufix4
  wire [3:0] count_from;  // ufix4
  reg [3:0] HDL_Counter_out1;  // ufix4
  wire [3:0] count;  // ufix4
  wire need_to_wrap;
  wire [3:0] count_value;  // ufix4
  wire [7:0] prelookup_comp_in_u;  // ufix8
  wire [3:0] prelookup_idx;  // ufix4
  wire signed [15:0] alpha1_D_Lookup_Table_table_data [0:15];  // sfix16_En10 [16]
  wire signed [15:0] alpha1_D_Lookup_Table_out1;  // sfix16_En10
  wire signed [31:0] Product1_mul_temp;  // sfix32_En20
  wire signed [15:0] Product1_out1;  // sfix16_En10
  wire signed [15:0] Constant_out1;  // sfix16_En10
  wire signed [31:0] Product_mul_temp;  // sfix32_En20
  wire signed [15:0] Product_out1;  // sfix16_En10
  reg signed [15:0] Delay_out1;  // sfix16_En10
  wire signed [15:0] Add_add_temp;  // sfix16_En10
  wire signed [15:0] Add_out1;  // int16
  wire signed [15:0] Data_Type_Conversion1_out1;  // sfix16_En10


  assign Constant1_out1 = 16'sb0000001000000000;

  // Count limited, Unsigned Counter
  //  initial value   = 0
  //  step value      = 1
  //  count to value  = 15
  assign count_step = 4'b0001;

  assign count_from = 4'b0000;

  assign enb = clk_enable;

  assign count = HDL_Counter_out1 + count_step;

  assign need_to_wrap = HDL_Counter_out1 == 4'b1111;

  assign count_value = (need_to_wrap == 1'b0 ? count :
              count_from);

  always @(posedge clk)
    begin : HDL_Counter_process
      if (reset == 1'b1) begin
        HDL_Counter_out1 <= 4'b0000;
      end
      else begin
        if (enb) begin
          HDL_Counter_out1 <= count_value;
        end
      end
    end

  assign prelookup_comp_in_u = {4'b0, HDL_Counter_out1};
  assign prelookup_idx = (prelookup_comp_in_u == 8'b00000000 ? 4'b0000 :
              (prelookup_comp_in_u >= 8'b00001111 ? 4'b1111 :
              HDL_Counter_out1));

  assign alpha1_D_Lookup_Table_table_data[0] = 16'sb0000000000000000;
  assign alpha1_D_Lookup_Table_table_data[1] = 16'sb0000000100000000;
  assign alpha1_D_Lookup_Table_table_data[2] = 16'sb0000001000000000;
  assign alpha1_D_Lookup_Table_table_data[3] = 16'sb0000001100000000;
  assign alpha1_D_Lookup_Table_table_data[4] = 16'sb0000010000000000;
  assign alpha1_D_Lookup_Table_table_data[5] = 16'sb0000001100000000;
  assign alpha1_D_Lookup_Table_table_data[6] = 16'sb0000001000000000;
  assign alpha1_D_Lookup_Table_table_data[7] = 16'sb0000000100000000;
  assign alpha1_D_Lookup_Table_table_data[8] = 16'sb0000000000000000;
  assign alpha1_D_Lookup_Table_table_data[9] = 16'sb1111111100000000;
  assign alpha1_D_Lookup_Table_table_data[10] = 16'sb1111111000000000;
  assign alpha1_D_Lookup_Table_table_data[11] = 16'sb1111110100000000;
  assign alpha1_D_Lookup_Table_table_data[12] = 16'sb1111110000000000;
  assign alpha1_D_Lookup_Table_table_data[13] = 16'sb1111110100000000;
  assign alpha1_D_Lookup_Table_table_data[14] = 16'sb1111111000000000;
  assign alpha1_D_Lookup_Table_table_data[15] = 16'sb1111111100000000;
  assign alpha1_D_Lookup_Table_out1 = alpha1_D_Lookup_Table_table_data[prelookup_idx];

  assign Product1_mul_temp = Constant1_out1 * alpha1_D_Lookup_Table_out1;
  assign Product1_out1 = Product1_mul_temp[25:10];

  assign Constant_out1 = 16'sb0000010000000000;

  assign Product_mul_temp = Constant_out1 * alpha1_D_Lookup_Table_out1;
  assign Product_out1 = Product_mul_temp[25:10];

  always @(posedge clk)
    begin : Delay_process
      if (reset == 1'b1) begin
        Delay_out1 <= 16'sb0000000000000000;
      end
      else begin
        if (enb) begin
          Delay_out1 <= Product_out1;
        end
      end
    end

  assign Add_add_temp = Product1_out1 + Delay_out1;
  assign Add_out1 = {{10{Add_add_temp[15]}}, Add_add_temp[15:10]};

  assign Data_Type_Conversion1_out1 = {Add_out1[5:0], 10'b0000000000};

  assign Out1 = Data_Type_Conversion1_out1;

  assign ce_out = clk_enable;

endmodule  // DSP_test